{
       This function outputs a PWM value to drive a single
       TIP-121 transistor on the base-leg of voice-coil motor.
       

   the sine wave is broken into 50 steps up and 50 steps down.
   Each step can be tuned to optimize the output characteristics of an individual circuit.

   Ken Bash

}  
CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

   
 
  higher = 24       ' inputs for external control  to eventually be used to tune the wave with external feedback
  lower = 25
  

VAR

  byte a              ' variables for wave look-up table 
  byte b
  byte c
  byte d
  byte e
  byte f
  byte g
  byte h
  byte j
  byte k

  byte a2
  byte b2
  byte c2
  byte d2
  byte e2
  byte f2
  byte g2
  byte h2
  byte j2
  byte k2         


  word  value       

  long sinedelay       ' delay on up cycle of the wave
  long sinedelay2      ' delay on down cycle of the wave   
                      
  long sine1[52]   ' table for up cycle steps
  
  long sine2[52]   ' table for down cycle steps
 

OBJ

  pwm: "pwmAsm"

pub Main         | duty , updn  , OVERTTMP

   sinedelay := 400000
   sinedelay2 :=940000             ' my system needed asymetric up/down timing 
   
 
   
 dira[higher] := 0             ' inputs for feedback tuning   ( not used here ) 
 dira[lower] := 0
 
 updn := 1
 duty := 0
       
      setabcs     
     setsine1                    ' set the lookup values
     setsine2
     
     pwm.start(8)
     pwm.SetPeriod(8000)         ' get into non-audible rang.


      repeat 
         runsine1                  ' endless repeat of the up/down sine-wave

     

pub setabcs                  ' set values for the look-up charts.

                         ' these values were selected by trial and error, watching the wave-output on another system. 
 
a := 30
b := 40
c := 50
d := 65
e := 80
f := 85
g := 88
h := 96
j := 97
k := 100

  
a2 := 99
b2 := 99
c2 := 99
d2 := 98
e2 := 97
f2 := 94
g2 := 80
h2 := 75
j2 := 60
k2 := 30     


pub sinedla
     waitcnt (cnt + sinedelay )

pub sinedla2
     waitcnt (cnt + sinedelay2 )
 
       
pub setsine2         ' set values into the lookup table
                     ' 50 up and 50 down values could be fine tuned further... but for now
                     ' just breaking them into blocks of 5 for a total of ten steps up and down on the wave. 


sine2[0] := a2
sine2[1] := a2
sine2[2] := a2
sine2[3] := a2
sine2[4] := a2   

sine2[5] := b2 
sine2[6] := b2
sine2[7] := b2
sine2[8] := b2
sine2[9] := b2


sine2[10] := c2  
sine2[11] := c2  
sine2[12] := c2  
sine2[13] := c2  
sine2[14] := c2      

sine2[15] := d2 
sine2[16] := d2  
sine2[17] := d2  
sine2[18] := d2  
sine2[19] := d2      

sine2[20] := e2
sine2[21] := e2  
sine2[22] := e2  
sine2[23] := e2  
sine2[24] := e2      

sine2[25] := f2 
sine2[26] := f2  
sine2[27] := f2  
sine2[28] := f2  
sine2[29] := f2  

sine2[30] := g2  
sine2[31] := g2  
sine2[32] := g2  
sine2[33] := g2  
sine2[34] := g2      

sine2[35] := h2 
sine2[36] := h2  
sine2[37] := h2  
sine2[38] := h2  
sine2[39] := h2   

sine2[40] := j2  
sine2[41] := j2  
sine2[42] := j2  
sine2[43] := j2  
sine2[44] := j2      

sine2[45] := k2 
sine2[46] := k2  
sine2[47] := k2  
sine2[48] := k2  
sine2[49] := k2

sine2[50] := k2     



pub setsine1                        ' set the up cycle PWM % values  ( for now in groups of 5 )

sine1[0] :=  a
sine1[1] :=  a
sine1[2] :=  a
sine1[3] :=  a
sine1[4] :=  a    

sine1[5] :=  b
sine1[6] :=  b
sine1[7] :=  b
sine1[8] :=  b
sine1[9] :=  b    

sine1[10] := c  
sine1[11] := c  
sine1[12] := c  
sine1[13] := c  
sine1[14] := c      

sine1[15] := d 
sine1[16] := d  
sine1[17] := d  
sine1[18] := d  
sine1[19] := d     

sine1[20] := e
sine1[21] := e  
sine1[22] := e  
sine1[23] := e  
sine1[24] := e      

sine1[25] := f 
sine1[26] := f  
sine1[27] := f  
sine1[28] := f  
sine1[29] := f

sine1[30] := g  
sine1[31] := g  
sine1[32] := g  
sine1[33] := g  
sine1[34] := g      

sine1[35] := h 
sine1[36] := h  
sine1[37] := h  
sine1[38] := h  
sine1[39] := h    

sine1[40] := j  
sine1[41] := j  
sine1[42] := j  
sine1[43] := j  
sine1[44] := j      

sine1[45] := k 
sine1[46] := k  
sine1[47] := k  
sine1[48] := k  
sine1[49] := k  


sine1[50] := k        


     
pub runsine1    | indx           ' output the up/down pwm output in 50 steps up, 50 steps down from a look-up table. 

indx := 0 
  
 repeat 50
          pwm.setduty( sine1[indx])
          sinedla
          indx++                      
 
indx := 1
 repeat 50
          pwm.setduty( sine2[indx])            
          sinedla2
          indx++

          


        